#include <stddef.h>
#include <stdint.h>

/* Defined by the main program. */
extern char const usage[];

/* Defined by the library. */
extern char const *progname;
extern unsigned argc;
extern char **argv;

void io_init(char const *, int, char **);
void write_all(int, char const *, size_t);
size_t read_all(int, char *, size_t);
void write_str(int, char const *);
void newline(int);
void write_line(int, char const *);
void write_u64_dec(int, uint64_t);
void write_err(char const *, char const *);
#define assert(expr) ((void) ((expr) || (assert_fail(#expr), 0)))
void assert_fail(char const *);
void perr(char const *);
int chkp(char const *, int);
void usage_err(char const *);
char const *fmt_u64_dec(uint64_t);
char *pop_arg(void);
int end_of_options(void);
unsigned parse_uint_option(char const *);
